'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactSwipeable = require('react-swipeable');

var _reactSwipeable2 = _interopRequireDefault(_reactSwipeable);

var _common = require('./common');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AliceCarousel = function (_React$Component) {
    _inherits(AliceCarousel, _React$Component);

    function AliceCarousel() {
        _classCallCheck(this, AliceCarousel);

        var _this = _possibleConstructorReturn(this, (AliceCarousel.__proto__ || Object.getPrototypeOf(AliceCarousel)).call(this));

        _this.state = {
            slides: [],
            currentIndex: 1,
            style: {
                transition: 'transform 0ms ease-out' }
        };

        _this._slideNext = _this._slideNext.bind(_this);
        _this._slidePrev = _this._slidePrev.bind(_this);
        _this._onTouchEnd = _this._onTouchEnd.bind(_this);
        _this._onTouchMove = _this._onTouchMove.bind(_this);
        _this._resizeHandler = _this._resizeHandler.bind(_this);
        _this._keyUpHandler = _this._keyUpHandler.bind(_this);
        _this._disableAnimation = _this._disableAnimation.bind(_this);
        _this._allowAnimation = _this._allowAnimation.bind(_this);
        _this._getActiveSlideIndex = _this._getActiveSlideIndex.bind(_this);
        _this._getStageComponentNode = _this._getStageComponentNode.bind(_this);
        _this._onMouseEnterAutoPlayHandler = _this._onMouseEnterAutoPlayHandler.bind(_this);
        _this._onMouseLeaveAutoPlayHandler = _this._onMouseLeaveAutoPlayHandler.bind(_this);
        return _this;
    }

    _createClass(AliceCarousel, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this._allowAnimation();
            this._setInitialState();
            window.addEventListener('resize', this._resizeHandler);

            if (!this.props.keysControlDisabled) {
                window.addEventListener('keyup', this._keyUpHandler);
            }

            if (this.props.autoPlay) this._play();
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (this.props.children !== nextProps.children) {
                this.setState({
                    slides: nextProps.children,
                    clones: this._cloneSlides(nextProps.children)
                });
            }

            if (this.props.responsive !== nextProps.responsive) {
                this.setState(this._calculateInitialProps(nextProps.responsive));
            }

            if (this.props.keysControlDisabled !== nextProps.keysControlDisabled) {
                nextProps.keysControlDisabled === true ? window.removeEventListener('keyup', this._keyUpHandler) : window.addEventListener('keyup', this._keyUpHandler);
            }

            if (this.props.autoPlayActionDisabled !== nextProps.autoPlayActionDisabled || this.props.autoPlayDirection !== nextProps.autoPlayDirection || this.props.autoPlayInterval !== nextProps.autoPlayInterval || this.props.autoPlay !== nextProps.autoPlay) {
                this._pause();
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps) {
            if (this.props.autoPlayActionDisabled !== prevProps.autoPlayActionDisabled || this.props.autoPlayDirection !== prevProps.autoPlayDirection || this.props.autoPlayInterval !== prevProps.autoPlayInterval || this.props.autoPlay !== prevProps.autoPlay) {
                if (this.props.autoPlay) {
                    this._play();
                }
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            window.removeEventListener('resize', this._resizeHandler);

            if (!this.props.keysControlDisabled) {
                window.removeEventListener('keyup', this._keyUpHandler);
            }
        }
    }, {
        key: '_cloneSlides',
        value: function _cloneSlides(children, itemsInSlide) {
            var slides = children || this.props.children;
            var items = itemsInSlide || this._setTotalItemsInSlide();
            var first = slides.slice(0, items);
            var last = slides.slice(slides.length - items);

            return last.concat(slides, first);
        }
    }, {
        key: '_calculateInitialProps',
        value: function _calculateInitialProps(totalItems) {
            var items = this._setTotalItemsInSlide(totalItems);
            var itemWidth = this.stageComponent.getBoundingClientRect().width / items;

            return {
                items: items,
                itemWidth: itemWidth,
                currentIndex: items,
                clones: this._cloneSlides(null, items),
                slides: this.props.children || [],
                translate3d: -itemWidth * items
            };
        }
    }, {
        key: '_setTotalItemsInSlide',
        value: function _setTotalItemsInSlide(totalItems) {
            var items = 1;
            var width = window.innerWidth;
            var length = this.props.children.length;

            if (this.props.responsive) {
                var responsive = totalItems || this.props.responsive || {};

                if (Object.keys(responsive).length) {
                    Object.keys(responsive).forEach(function (key) {
                        if (key < width) items = Math.min(responsive[key].items, length) || items;
                    });
                }
            }
            return items;
        }
    }, {
        key: '_setInitialState',
        value: function _setInitialState() {
            this.setState(this._calculateInitialProps());
        }
    }, {
        key: '_resizeHandler',
        value: function _resizeHandler() {
            this._setInitialState();
        }
    }, {
        key: '_getStageComponentNode',
        value: function _getStageComponentNode(node) {
            this.stageComponent = node;
        }
    }, {
        key: '_getDuration',
        value: function _getDuration() {
            return this.props.duration || 250;
        }
    }, {
        key: '_allowAnimation',
        value: function _allowAnimation() {
            this.allowAnimation = true;
        }
    }, {
        key: '_disableAnimation',
        value: function _disableAnimation() {
            this.allowAnimation = false;
        }
    }, {
        key: '_isHovered',
        value: function _isHovered() {
            return this.isHovered;
        }
    }, {
        key: '_checkRecalculation',
        value: function _checkRecalculation() {
            var _state = this.state,
                items = _state.items,
                slides = _state.slides,
                currentIndex = _state.currentIndex;

            var recalculate = currentIndex === 0 || currentIndex === slides.length + items;

            recalculate ? this._recalculateSlidePosition() : this._onSlideChange();
        }
    }, {
        key: '_recalculateSlidePosition',
        value: function _recalculateSlidePosition() {
            var _this2 = this;

            var _state2 = this.state,
                items = _state2.items,
                itemWidth = _state2.itemWidth,
                slides = _state2.slides,
                currentIndex = _state2.currentIndex;


            this.setState({
                currentIndex: currentIndex === 0 ? slides.length : items,
                translate3d: -itemWidth * (currentIndex === 0 ? slides.length : items),
                style: { transition: 'transform 0ms ease-out' }
            }, function () {
                return _this2._onSlideChange();
            });
        }
    }, {
        key: '_onSlideChange',
        value: function _onSlideChange() {
            if (this.props.onSlideChange) {
                this.props.onSlideChange(this._getActiveSlideIndex());
            }
            this._allowAnimation();
        }
    }, {
        key: '_prevButton',
        value: function _prevButton() {
            return _react2.default.createElement(
                'div',
                { className: 'alice-carousel__prev-btn' },
                _react2.default.createElement(
                    'div',
                    { className: 'alice-carousel__prev-btn-wrapper',
                        onMouseEnter: this._onMouseEnterAutoPlayHandler,
                        onMouseLeave: this._onMouseLeaveAutoPlayHandler
                    },
                    _react2.default.createElement('div', { className: 'alice-carousel__prev-btn-item',
                        onClick: this._slidePrev
                    })
                )
            );
        }
    }, {
        key: '_nextButton',
        value: function _nextButton() {
            return _react2.default.createElement(
                'div',
                { className: 'alice-carousel__next-btn' },
                _react2.default.createElement(
                    'div',
                    { className: 'alice-carousel__next-btn-wrapper',
                        onMouseEnter: this._onMouseEnterAutoPlayHandler,
                        onMouseLeave: this._onMouseLeaveAutoPlayHandler
                    },
                    _react2.default.createElement('div', { className: 'alice-carousel__next-btn-item',
                        onClick: this._slideNext
                    })
                )
            );
        }
    }, {
        key: '_getActiveSlideIndex',
        value: function _getActiveSlideIndex() {
            var _state3 = this.state,
                slides = _state3.slides,
                items = _state3.items,
                currentIndex = _state3.currentIndex;

            var slidesLength = slides.length;

            var dotsLength = slidesLength % items === 0 ? Math.floor(slidesLength / items) - 1 : Math.floor(slidesLength / items);

            if (items === 1) {
                if (currentIndex < items) {
                    return slidesLength - items;
                } else if (currentIndex > slidesLength) {
                    return 0;
                } else {
                    return currentIndex - 1;
                }
            } else {
                if (currentIndex === slidesLength + items) {
                    return 0;
                } else if (currentIndex < items && currentIndex !== 0) {
                    return dotsLength;
                } else if (currentIndex === 0) {
                    return slidesLength % items === 0 ? dotsLength : dotsLength - 1;
                } else {
                    return Math.floor(currentIndex / items) - 1;
                }
            }
        }
    }, {
        key: '_renderDotsNavigation',
        value: function _renderDotsNavigation() {
            var _this3 = this;

            var _state4 = this.state,
                slides = _state4.slides,
                items = _state4.items;


            return _react2.default.createElement(
                'ul',
                { className: 'alice-carousel__dots' },
                slides.map(function (item, i) {
                    if (i < slides.length / items) {
                        return _react2.default.createElement('li', {
                            key: i,
                            onClick: function onClick() {
                                return _this3._slideToItem(i + 1);
                            },
                            onMouseEnter: _this3._onMouseEnterAutoPlayHandler,
                            onMouseLeave: _this3._onMouseLeaveAutoPlayHandler,
                            className: 'alice-carousel__dots-item' + (_this3._getActiveSlideIndex() === i ? ' __active' : '')
                        });
                    }
                })
            );
        }
    }, {
        key: '_renderPlayPauseButton',
        value: function _renderPlayPauseButton() {
            var _this4 = this;

            return _react2.default.createElement(
                'div',
                { className: 'alice-carousel__play-btn', onClick: function onClick() {
                        return _this4._playPauseToggle();
                    } },
                _react2.default.createElement(
                    'div',
                    { className: 'alice-carousel__play-btn-wrapper' },
                    _react2.default.createElement('div', { className: 'alice-carousel__play-btn-item' + (this.state.isPlaying ? ' __pause' : '') })
                )
            );
        }
    }, {
        key: '_play',
        value: function _play() {
            var _this5 = this;

            var _props = this.props,
                autoPlayDirection = _props.autoPlayDirection,
                autoPlayInterval = _props.autoPlayInterval;

            var playInterval = typeof autoPlayInterval === 'number' ? Math.max(autoPlayInterval, this._getDuration()) : this._getDuration();

            this.setState({ isPlaying: true });

            if (!this._autoPlayIntervalId) {
                this._autoPlayIntervalId = window.setInterval(function () {
                    if (!_this5._isHovered() && _this5._autoPlayIntervalId) {
                        // check interval if force click

                        if (!_this5.allowAnimation) return;
                        autoPlayDirection === 'rtl' ? _this5._slidePrev(false) : _this5._slideNext(false);
                    }
                }, playInterval);
            }
        }
    }, {
        key: '_pause',
        value: function _pause() {
            if (this._autoPlayIntervalId) {
                window.clearInterval(this._autoPlayIntervalId);
                this._autoPlayIntervalId = null;
                this.setState({ isPlaying: false });
            }
        }
    }, {
        key: '_playPauseToggle',
        value: function _playPauseToggle() {
            this.state.isPlaying ? this._pause() : this._play();
        }
    }, {
        key: '_keyUpHandler',
        value: function _keyUpHandler(e) {
            if (!this.allowAnimation) return;

            switch (e.keyCode) {
                case 37:
                    this._slidePrev();
                    break;
                case 39:
                    this._slideNext();
                    break;
            }
        }
    }, {
        key: '_slidePrev',
        value: function _slidePrev() {
            var action = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

            if (action && this.props.autoPlayActionDisabled) {
                this._pause();
            }

            var _state5 = this.state,
                currentIndex = _state5.currentIndex,
                items = _state5.items;

            this._slideToItem((currentIndex - 1) / items);
        }
    }, {
        key: '_slideNext',
        value: function _slideNext() {
            var action = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

            if (action && this.props.autoPlayActionDisabled) {
                this._pause();
            }

            var _state6 = this.state,
                currentIndex = _state6.currentIndex,
                items = _state6.items;

            this._slideToItem((currentIndex + 1) / items);
        }
    }, {
        key: '_slideToItem',
        value: function _slideToItem(index, position) {
            var _this6 = this;

            if (!this.allowAnimation) return;
            this._disableAnimation();

            var _state7 = this.state,
                items = _state7.items,
                itemWidth = _state7.itemWidth;

            var translate = position || index * items * itemWidth;
            var duration = this._getDuration();
            var currentIndex = index * items;

            this.setState({
                currentIndex: currentIndex,
                translate3d: -translate,
                style: { transition: 'transform ' + duration + 'ms ease-out' }
            }, function () {
                return window.setTimeout(function () {
                    return _this6._checkRecalculation();
                }, duration);
            });
        }
    }, {
        key: '_onTouchMove',
        value: function _onTouchMove() {
            this._onMouseEnterAutoPlayHandler();
            if (this.props.swipeDisabled) return;

            var _state8 = this.state,
                slides = _state8.slides,
                items = _state8.items,
                itemWidth = _state8.itemWidth,
                translate3d = _state8.translate3d;

            var maxPosition = (slides.length + items) * itemWidth;
            var direction = arguments[1] > 0 ? 'LEFT' : 'RIGHT';
            var position = translate3d - arguments[1];

            if (position >= 0 || Math.abs(position) >= maxPosition) {
                recalculatePosition();
            }

            (0, _common.setTransformAnimation)(this.stageComponent, position, 0);
            this.swipePosition = { position: position, direction: direction };

            function recalculatePosition() {
                direction === 'RIGHT' ? position += -slides.length * itemWidth : position += maxPosition - items * itemWidth;

                if (position >= 0 || Math.abs(position) >= maxPosition) {
                    recalculatePosition();
                }
            }
        }
    }, {
        key: '_onTouchEnd',
        value: function _onTouchEnd() {
            if (this.props.swipeDisabled) return;
            this._onMouseLeaveAutoPlayHandler();
            this._allowAnimation();

            var _state9 = this.state,
                itemWidth = _state9.itemWidth,
                items = _state9.items;

            var swipePosition = Math.abs(this.swipePosition.position);
            var currentIndex = this.swipePosition.direction === 'LEFT' ? Math.floor(swipePosition / itemWidth) + 1 : Math.floor(swipePosition / itemWidth);

            var position = currentIndex * itemWidth;

            (0, _common.setTransformAnimation)(this.stageComponent, -position, this._getDuration());
            this._slideToItem(currentIndex / items, position);
        }
    }, {
        key: '_onMouseEnterAutoPlayHandler',
        value: function _onMouseEnterAutoPlayHandler() {
            this.isHovered = true;
        }
    }, {
        key: '_onMouseLeaveAutoPlayHandler',
        value: function _onMouseLeaveAutoPlayHandler() {
            this.isHovered = false;
        }
    }, {
        key: 'render',
        value: function render() {
            var _this7 = this;

            var style = _extends({}, this.state.style, { transform: 'translate3d(' + this.state.translate3d + 'px, 0, 0)' });
            var slides = this.state.clones || this.state.slides;

            return _react2.default.createElement(
                'div',
                { className: 'alice-carousel' },
                _react2.default.createElement(
                    _reactSwipeable2.default,
                    { onSwiping: this._onTouchMove, onSwiped: this._onTouchEnd },
                    _react2.default.createElement(
                        'div',
                        { className: 'alice-carousel__wrapper',
                            onMouseEnter: this._onMouseEnterAutoPlayHandler,
                            onMouseLeave: this._onMouseLeaveAutoPlayHandler
                        },
                        _react2.default.createElement(
                            'ul',
                            { className: 'alice-carousel__stage', ref: this._getStageComponentNode, style: style },
                            slides.map(function (item, i) {
                                return _react2.default.createElement(
                                    'li',
                                    {
                                        className: 'alice-carousel__stage-item', key: i,
                                        style: { width: _this7.state.itemWidth + 'px' }
                                    },
                                    item
                                );
                            })
                        )
                    )
                ),
                !this.props.buttonsDisabled ? this._prevButton() : null,
                !this.props.buttonsDisabled ? this._nextButton() : null,
                !this.props.dotsDisabled ? this._renderDotsNavigation() : null,
                !this.props.playButtonDisabled ? this._renderPlayPauseButton() : null
            );
        }
    }]);

    return AliceCarousel;
}(_react2.default.Component);

AliceCarousel.propTypes = {
    children: _react2.default.PropTypes.array.isRequired,
    onSlideChange: _react2.default.PropTypes.func,
    keysControlDisabled: _react2.default.PropTypes.bool,
    playButtonDisabled: _react2.default.PropTypes.bool,
    buttonsDisabled: _react2.default.PropTypes.bool,
    dotsDisabled: _react2.default.PropTypes.bool,
    swipeDisabled: _react2.default.PropTypes.bool,
    responsive: _react2.default.PropTypes.object,
    duration: _react2.default.PropTypes.number,
    autoPlay: _react2.default.PropTypes.bool,
    autoPlayInterval: _react2.default.PropTypes.number,
    autoPlayDirection: _react2.default.PropTypes.string,
    autoPlayActionDisabled: _react2.default.PropTypes.bool
};

exports.default = AliceCarousel;